(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/router'), require('rxjs/add/operator/filter'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/router', 'rxjs/add/operator/filter', '@angular/common'], factory) :
    (factory((global.ng = global.ng || {}, global.ng.angularNavTitle = global.ng.angularNavTitle || {}),global.ng.core,global.ng.router,global.rxjs_add_operator_filter,global.ng.common));
}(this, (function (exports,_angular_core,_angular_router,rxjs_add_operator_filter,_angular_common) { 'use strict';

// default 
var ROUTE_DATA_PARAM = 'navTitle';
var NavTitle = (function () {
    function NavTitle() {
    }
    return NavTitle;
}());
var NavTitleComponent = (function () {
    function NavTitleComponent(activatedRouteSnapshot, router) {
        this.activatedRouteSnapshot = activatedRouteSnapshot;
        this.router = router;
        this.separator = '–';
        this.dataParam = ROUTE_DATA_PARAM;
        this.titles = [];
    }
    NavTitleComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.router.events
            .filter(function (event) { return event instanceof _angular_router.NavigationEnd; })
            .subscribe(function (event) {
            _this.titles = _this.getNavTitles(_this.activatedRouteSnapshot.snapshot);
        });
    };
    NavTitleComponent.prototype.getLastChildRoute = function (activatedSnapshot) {
        var children = activatedSnapshot.children;
        if (children.length === 0) {
            return activatedSnapshot;
        }
        return this.getLastChildRoute(children[0]);
    };
    NavTitleComponent.prototype.getNavTitles = function (activatedSnapshot) {
        var pathFromRoute = this.getLastChildRoute(activatedSnapshot).pathFromRoot;
        var titles = [];
        for (var _i = 0, pathFromRoute_1 = pathFromRoute; _i < pathFromRoute_1.length; _i++) {
            var route = pathFromRoute_1[_i];
            if (route.data.hasOwnProperty(this.dataParam) && typeof route.data[this.dataParam] === 'string') {
                titles.push({
                    label: route.data[this.dataParam],
                    url: route.pathFromRoot.filter(function (r) { return r.url.length > 0; }).map(function (r) { return r.url[0]; }).join('/')
                });
            }
        }
        return titles;
    };
    NavTitleComponent.decorators = [
        { type: _angular_core.Component, args: [{
                    selector: 'nav-title',
                    template: "<span *ngFor=\"let t of titles; let last = last;\">\n      <a routerLink=\"t.url\">{{t.label}}</a><span *ngIf=\"!last\"> {{separator}}</span>\n    </span>",
                    styles: ['a{text-decoration:none;}']
                },] },
    ];
    /** @nocollapse */
    NavTitleComponent.ctorParameters = function () { return [
        { type: _angular_router.ActivatedRoute, },
        { type: _angular_router.Router, },
    ]; };
    NavTitleComponent.propDecorators = {
        'separator': [{ type: _angular_core.Input },],
        'dataParam': [{ type: _angular_core.Input },],
    };
    return NavTitleComponent;
}());

var NavTitleModule = (function () {
    function NavTitleModule() {
    }
    NavTitleModule.decorators = [
        { type: _angular_core.NgModule, args: [{
                    declarations: [NavTitleComponent],
                    exports: [NavTitleComponent],
                    imports: [_angular_common.CommonModule]
                },] },
    ];
    /** @nocollapse */
    NavTitleModule.ctorParameters = function () { return []; };
    return NavTitleModule;
}());

exports.NavTitleModule = NavTitleModule;
exports.NavTitle = NavTitle;
exports.NavTitleComponent = NavTitleComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
